import "core-js/modules/es6.array.for-each";
import "core-js/modules/es6.array.map";
import "core-js/modules/es6.object.assign";
import "core-js/modules/es6.date.to-iso-string";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

import ConsoleProxy from "../console-proxy";
var instance;
export var Logger = function () {
  function Logger() {
    var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Logger);

    this._defaultConsoleOptions = {
      level: "info",
      levels: Logger._levels
    };
    this._defaultWinstonOptions = {
      exitOnError: false,
      level: "info",
      levels: Logger._levels,
      transports: {
        Console: {
          colorize: true,
          handleExceptions: true,
          json: true,
          timestamp: function timestamp() {
            return new Date().toISOString();
          }
        }
      }
    };
    var consoleOptions = args.consoleOptions,
        _args$newInstance = args.newInstance,
        newInstance = _args$newInstance === void 0 ? false : _args$newInstance,
        winstonOptions = args.winstonOptions;
    if (instance && !newInstance) return instance;

    if (process.env.WEB_ENV) {
      var ConsolePrxy = require("../console-proxy").default;

      this._client = this._initializeConsole(ConsolePrxy, consoleOptions);
    } else {
      var winston = require("winston");

      this._client = this._initializeWinston(winston, winstonOptions);
    }

    instance = this;
    return instance;
  }

  _createClass(Logger, [{
    key: "debug",
    value: function debug(message, meta) {
      this._log("debug", message, meta);
    }
  }, {
    key: "error",
    value: function error(message, meta) {
      this._log("error", message, meta);
    }
  }, {
    key: "info",
    value: function info(message, meta) {
      this._log("info", message, meta);
    }
  }, {
    key: "verbose",
    value: function verbose(message, meta) {
      this._log("verbose", message, meta);
    }
  }, {
    key: "warn",
    value: function warn(message, meta) {
      this._log("warn", message, meta);
    }
  }, {
    key: "_initializeConsole",
    value: function _initializeConsole(ConsolePrxy) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return new ConsoleProxy(Object.assign({}, this._defaultConsoleOptions, options));
    }
  }, {
    key: "_initializeWinston",
    value: function _initializeWinston(winston) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var mergedOptions = this._mergeWinstonOptions(winston, options);

      var transports = [];

      if (mergedOptions.transports) {
        var mergedOptionsTransports = mergedOptions.transports;
        Object.keys(mergedOptionsTransports).map(function (key) {
          var WinstonTransport = winston.transports[key];
          transports.push(new WinstonTransport(mergedOptionsTransports[key]));
        });
      }

      return new winston.Logger(Object.assign({}, mergedOptions, {
        transports: transports
      }));
    }
  }, {
    key: "_log",
    value: function _log(level, message, meta) {
      if (process.env.ISO_LOG === "false") return;

      this._client.log(level, message, meta);
    }
  }, {
    key: "_mergeWinstonOptions",
    value: function _mergeWinstonOptions(winston, options) {
      if (options.transports) {
        var transportOptions = options.transports;
        var validOptions = {};
        Object.keys(transportOptions).forEach(function (key) {
          if (key in winston.transports) {
            validOptions[key] = transportOptions[key];
          }
        });
        options.transports = validOptions;
      }

      return Object.assign({}, this._defaultWinstonOptions, options);
    }
  }, {
    key: "client",
    get: function get() {
      return this._client;
    }
  }]);

  return Logger;
}();
Logger._levels = {
  error: 0,
  warn: 1,
  info: 2,
  verbose: 3,
  debug: 4
};
//# sourceMappingURL=index.js.map
