"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

class ConsoleProxy {
  constructor({
    level,
    levels
  }) {
    this._console = console;
    this._level = level;
    this._levels = levels;
    this._maxLevel = this._levels[this._level];
  }

  get console() {
    return this._console;
  }

  log(level, message, meta = {}) {
    const cmd = level !== "error" && level !== "warn" && level !== "info" ? "log" : level;

    if (this._levels[level] <= this._maxLevel) {
      meta.level = level;
      meta.timestamp = new Date().toISOString();

      this._console[cmd](message, meta);
    }
  }

}

exports.default = ConsoleProxy;
//# sourceMappingURL=index.js.map
