/// <reference types="winston" />
import { LoggerInstance } from "winston";
import ConsoleProxy from "../console-proxy";
import { LoggerArgs } from "../types";
/**
 * An isomorphic logger that uses Winston on
 * the server and console on the client.
 *
 */
export declare class Logger {
    private static _levels;
    private _client;
    private _defaultConsoleOptions;
    private _defaultWinstonOptions;
    constructor(args?: LoggerArgs);
    readonly client: ConsoleProxy | LoggerInstance;
    debug(message: string, meta?: any): void;
    error(message: string, meta?: any): void;
    info(message: string, meta?: any): void;
    verbose(message: string, meta?: any): void;
    warn(message: string, meta?: any): void;
    private _initializeConsole(ConsolePrxy, options?);
    private _initializeWinston(winston, options?);
    private _log(level, message, meta?);
    private _mergeWinstonOptions(winston, options);
}
